--------------------------------------------------------------------------------
-- Company: UNIVERSITY OF CONNECTICUT
-- Engineer: Farrukh Hijaz
--
-- Create Date:    09/15/2015
-- Design Name:    
-- Module Name:    wb_eightcharled
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description: Master wishbone module that waits for interrupts 
--              from the ps2_kb module and then reads the scancode from the ps2_kb module
--              and then converts the scancode to ascii which is then written to 
--              the wb_eightcharled module.
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity wb_eightcharled is
	Port ( clk_i : in std_logic;
          rst_i : in std_logic;
		    adr_i : in std_logic_vector(31 downto 0);
          dat_i : in std_logic_vector(31 downto 0);
          dat_o : out std_logic_vector(31 downto 0);
          ack_o : out std_logic;
          stb_i : in std_logic;
          we_i  : in std_logic;
			 segment : out std_logic_vector(6 downto 0);
          an : out std_logic_vector(3 downto 0);
          dp : out std_logic
		);
end wb_eightcharled;

architecture Behavioral of wb_eightcharled is
	signal char0, char1, char2, char3 : std_logic_vector(7 downto 0);
	signal char4, char5, char6, char7 : std_logic_vector(7 downto 0);
	signal onemsec_clk : std_logic;
begin

 	onemsec_clk_divider : entity work.clock_divider
		generic map ( divisor => 2**16 )
		port map ( clk_in => clk_i, reset => rst_i, clk_out => onemsec_clk );

	-- convert eight characters to the appropriate digit and segment signals
	string2leds : entity work.string2leds
		port map ( char0 => char0, char1 => char1, char2 =>char2, char3 => char3,
					  char4 => char4, char5 => char5, char6 =>char6, char7 => char7,
					  onemsec_clk => onemsec_clk, 
					  sys_rst => rst_i,
				 	  enable => '1',
				     segment => segment,
			 	 	  an => an,
					  dp => dp );

					  
	-- if it is a backspace or delete key, shift the characters
	-- down one and add it a space at the beginning.  Otherwise,
	-- shift the characters up one and put the new character at the end.



	-- always acknowledge writes, since there are no wait delays to be inserted
	ack_o <= '1';

end Behavioral;

