--------------------------------------------------------------------------------
-- Company: UNIVERSITY OF CONNECTICUT
-- Engineer: Farrukh Hijaz
--
-- Create Date:    09/15/2015
-- Design Name:    
-- Module Name:    wb_kb_reader - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description: Master wishbone module that waits for interrupts 
--              from the ps2_kb module and then reads the scancode from the ps2_kb module
--              and then converts the scancode to ascii which is then written to 
--              the wb_eightcharled module.
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity wb_kb_reader is
	Port ( clk_i : in std_logic;
			rst_i : in std_logic;
			adr_o : out std_logic_vector(31 downto 0);
			dat_i : in std_logic_vector(31 downto 0);
			dat_o : out std_logic_vector(31 downto 0);
			ack_i : in std_logic;
			cyc_o : out std_logic;
			stb_o : out std_logic;
			we_o  : out std_logic;
			irq_i : in std_logic;
			leds_o : out std_logic_vector(7 downto 0);
			irqv_i: in std_logic_vector(1 downto 0));
end wb_kb_reader;

architecture Behavioral of wb_kb_reader is
	-- Add other signals as required.
	signal code, ascii : std_logic_vector(7 downto 0);
	signal shift, ctrl, alt : std_logic;
begin

	-- convert the scancode signal given the shift, ctrl, and alt flags into
	-- an eight bit ASCII signal.
	s2a : entity work.scancode2ascii
		port map ( scancode => code,
						ascii => ascii,
						shift => shift,
						ctrl => ctrl,
						alt => alt );

	-- Design a state machine that receives a scancode form the wb_ps2_kb slave.
	-- It asserts appropriate flags based on the code received.
	-- This scancode along with the flags are converted to ASCII value using the scancode2ascii module.
	-- The ASCII value is then sent to the display slave.
	

end Behavioral;
